diff a/test/micro/org/openjdk/bench/valhalla/field/copy/Inline64long.java b/test/micro/org/openjdk/bench/valhalla/field/copy/Inline64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/copy/Inline64long.java
@@ -0,0 +1,194 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.copy;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ64long;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64long extends StatesQ64long {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Obj_to_Obj_copy(ObjState s, ObjState d) {
+        ObjWrapper[] src = s.arr;
+        ObjWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Obj_to_Int_copy(ObjState s, IntState d) {
+        ObjWrapper[] src = s.arr;
+        IntWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = (Int64) src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Obj_to_Ref_copy(ObjState s, RefState d) {
+        ObjWrapper[] src = s.arr;
+        RefWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = (Q64long)src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Obj_to_Val_copy(ObjState s, ValState d) {
+        ObjWrapper[] src = s.arr;
+        ValWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = (Q64long) src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Int_to_Obj_copy(IntState s, ObjState d) {
+        IntWrapper[] src = s.arr;
+        ObjWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Int_to_Int_copy(IntState s, IntState d) {
+        IntWrapper[] src = s.arr;
+        IntWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Int_to_Ref_copy(IntState s, RefState d) {
+        IntWrapper[] src = s.arr;
+        RefWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = (Q64long)src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Int_to_Val_copy(IntState s, ValState d) {
+        IntWrapper[] src = s.arr;
+        ValWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = (Q64long) src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Obj_copy(RefState s, ObjState d) {
+        RefWrapper[] src = s.arr;
+        ObjWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Int_copy(RefState s, IntState d) {
+        RefWrapper[] src = s.arr;
+        IntWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_copy(RefState s, RefState d) {
+        RefWrapper[] src = s.arr;
+        RefWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_copy(RefState s, ValState d) {
+        RefWrapper[] src = s.arr;
+        ValWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Obj_copy(ValState s, ObjState d) {
+        ValWrapper[] src = s.arr;
+        ObjWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Int_copy(ValState s, IntState d) {
+        ValWrapper[] src = s.arr;
+        IntWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_copy(ValState s, RefState d) {
+        ValWrapper[] src = s.arr;
+        RefWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_copy(ValState s, ValState d) {
+        ValWrapper[] src = s.arr;
+        ValWrapper[] dst = d.arr;
+        for (int i = 0; i < src.length; i++) {
+            dst[i].f = src[i].f;
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive128.java b/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive128.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive128.java
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.copy;
+
+import org.openjdk.bench.valhalla.field.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive128 extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p128int_copy(Primitive128int s, Primitive128int d) {
+        P128int[] src = s.arr;
+        P128int[] dst = d.arr;
+        for(int i=0; i<src.length; i++) {
+            dst[i].f0 = src[i].f0;
+            dst[i].f1 = src[i].f1;
+            dst[i].f2 = src[i].f2;
+            dst[i].f3 = src[i].f3;
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive32.java b/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive32.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive32.java
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.copy;
+
+import org.openjdk.bench.valhalla.field.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive32 extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p32int_copy(Primitive32int s, Primitive32int d) {
+        P32int[] src = s.arr;
+        P32int[] dst = d.arr;
+        for(int i=0; i<src.length; i++) {
+            dst[i].f0 = src[i].f0;
+        }
+    }
+
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive64.java b/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive64.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/copy/Primitive64.java
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.copy;
+
+import org.openjdk.bench.valhalla.field.util.PrimitiveStates;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Primitive64 extends PrimitiveStates {
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p64byte_copy(Primitive64byte s, Primitive64byte d) {
+        P64byte[] src = s.arr;
+        P64byte[] dst = d.arr;
+        for(int i=0; i<src.length; i++) {
+            dst[i].f0 = src[i].f0;
+            dst[i].f1 = src[i].f1;
+            dst[i].f2 = src[i].f2;
+            dst[i].f3 = src[i].f3;
+            dst[i].f4 = src[i].f4;
+            dst[i].f5 = src[i].f5;
+            dst[i].f6 = src[i].f6;
+            dst[i].f7 = src[i].f7;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p64int_copy(Primitive64int s, Primitive64int d) {
+        P64int[] src = s.arr;
+        P64int[] dst = d.arr;
+        for(int i=0; i<src.length; i++) {
+            dst[i].f0 = src[i].f0;
+            dst[i].f1 = src[i].f1;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void p64long_copy(Primitive64long s, Primitive64long d) {
+        P64long[] src = s.arr;
+        P64long[] dst = d.arr;
+        for(int i=0; i<src.length; i++) {
+            dst[i].f0 = src[i].f0;
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/read/Inline128int.java b/test/micro/org/openjdk/bench/valhalla/field/read/Inline128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/read/Inline128int.java
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.read;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ128int;
+import org.openjdk.bench.valhalla.types.Q128int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline128int extends StatesQ128int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q128int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q128int v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_read(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/read/Inline32int.java b/test/micro/org/openjdk/bench/valhalla/field/read/Inline32int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/read/Inline32int.java
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.read;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ32int;
+import org.openjdk.bench.valhalla.types.Q32int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline32int extends StatesQ32int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q32int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q32int v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_read(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/read/Inline64byte.java b/test/micro/org/openjdk/bench/valhalla/field/read/Inline64byte.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/read/Inline64byte.java
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.read;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ64byte;
+import org.openjdk.bench.valhalla.types.Q64byte;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64byte extends StatesQ64byte {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q64byte v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q64byte v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_read(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/read/Inline64int.java b/test/micro/org/openjdk/bench/valhalla/field/read/Inline64int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/read/Inline64int.java
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.read;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ64int;
+import org.openjdk.bench.valhalla.types.Q64int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64int extends StatesQ64int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q64int v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q64int v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_read(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/read/Inline64long.java b/test/micro/org/openjdk/bench/valhalla/field/read/Inline64long.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/read/Inline64long.java
@@ -0,0 +1,121 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.read;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ64long;
+import org.openjdk.bench.valhalla.types.Int64;
+import org.openjdk.bench.valhalla.types.Q64long;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline64long extends StatesQ64long {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void val_consume(Q64long v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void ref_consume(Q64long v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void int_consume(Int64 v) {
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void obj_consume(Object v) {
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Int_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Obj_read(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            obj_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_read(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            val_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_read(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            ref_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Int_read(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            int_consume(arr[i].f);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Obj_read(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for(int i=0; i < arr.length; i++) {
+            obj_consume(arr[i].f);
+        }
+    }
+
+}
diff a/test/micro/org/openjdk/bench/valhalla/field/set/Inline128int.java b/test/micro/org/openjdk/bench/valhalla/field/set/Inline128int.java
--- /dev/null
+++ b/test/micro/org/openjdk/bench/valhalla/field/set/Inline128int.java
@@ -0,0 +1,114 @@
+/*
+ * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.bench.valhalla.field.set;
+
+import org.openjdk.bench.valhalla.field.util.StatesQ128int;
+import org.openjdk.bench.valhalla.types.Q128int;
+import org.openjdk.jmh.annotations.Benchmark;
+import org.openjdk.jmh.annotations.CompilerControl;
+
+public class Inline128int extends StatesQ128int {
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q128int getRef(int i) {
+        return new Q128int(i);
+    }
+
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public static Q128int getVal(int i) {
+        return new Q128int(i);
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q128int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Val_set(ValState st) {
+        ValWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q128int()  ;
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void New_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q128int(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Ref_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getRef(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Val_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = getVal(i);
+        }
+    }
+
+    @Benchmark
+    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
+    public void Def_to_Ref_set(RefState st) {
+        RefWrapper[] arr = st.arr;
+        for (int i = 0; i < arr.length; i++) {
+            arr[i].f = new Q128int()  ;
+        }
+    }
+
+}
